--[[

This is my attempt of creating an alternative UI for your raid vitals. It is heavily inspired by moebius92's plugin "PartyFrame" and I used parts of his code for the "reloader" and the "party effects".

]]

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

--[[if Turbine.Shell.IsCommand("hilfe") then
	import "EruadarionPlugins.RaidHealz.de";
elseif Turbine.Shell.IsCommand("help") then
	import "EruadarionPlugins.RaidHealz.en";
elseif Turbine.Shell.IsCommand("aide") then
	import "EruadarionPlugins.RaidHealz.fr";
else
	Turbine.Shell.WriteLine("[RaidHealz] Your client language is currently not supported - Sorry!")
end]]

import "EruadarionPlugins.RaidHealz.en";
import "EruadarionPlugins.RaidHealz.misc";
import "EruadarionPlugins.RaidHealz.DefaultSettings";
import "EruadarionPlugins.RaidHealz.LabelledComboBox";

local reload = Turbine.UI.Control();
reload.state = 0;
function reload:Update()
	if self.state == 1 then
		Turbine.PluginManager.UnloadScriptState("RaidHealzReloader");
	elseif self.state > 0 then
		self:SetWantsUpdates(false);
		reload = nil;
	end

	self.state = self.state + 1;
end
reload:SetWantsUpdates(true);

MyPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
MyName = MyPlayer:GetName();
MyParty = MyPlayer:GetParty();

Player = {};

if MyParty ~= nil then
	MemberCount = MyParty:GetMemberCount();
	for i = 1, MemberCount, 1 do
		Player[i] = {};
		Player[i].member = MyParty:GetMember(i);
	end
else
	MemberCount = 1;
	Player[1] = {};
	Player[1].member = MyPlayer;
end

for i = 1, MemberCount, 1 do
	Player[i].name = Player[i].member:GetName();
	if Settings.PlayerName.MaxCharacters == 0 then
		Player[i].name_short = Player[i].name;
	else
		Player[i].name_short = string.sub(Player[i].name, 1, Settings.PlayerName.MaxCharacters);
	end
	Player[i].class = Player[i].member:GetClass();
	Player[i].morale = round(Player[i].member:GetMorale());
	Player[i].maxmorale = round(Player[i].member:GetMaxMorale());
	Player[i].basemaxmorale = round(Player[i].member:GetBaseMaxMorale());
	Player[i].maxtemporarymorale = round(Player[i].member:GetMaxTemporaryMorale());
	Player[i].temporarymorale = round(Player[i].member:GetTemporaryMorale());
	if Settings.MoraleLabel.Mode == 1 then
		if Settings.MoraleLabel.Short then
			Player[i].moralestring = math.floor(Player[i].morale / 1000).."."..math.floor((Player[i].morale % 1000) / 100).."/"..math.floor(Player[i].maxmorale / 1000).."."..math.floor((Player[i].maxmorale % 1000) / 100);
		else
			Player[i].moralestring = formatNumber(math.floor(Player[i].morale)).."/"..formatNumber(math.floor(Player[i].maxmorale));
		end
	elseif Settings.MoraleLabel.Mode == 2 and Player[i].morale ~= Player[i].maxmorale then
		if Settings.MoraleLabel.Short then
			Player[i].moralestring = "-"..math.floor((Player[i].maxmorale - Player[i].morale) / 1000).."."..math.floor(((Player[i].maxmorale - Player[i].morale) % 1000) / 100);
		else
			Player[i].moralestring = "-"..formatNumber(math.floor(Player[i].maxmorale - Player[i].morale));
		end
	else
		Player[i].moralestring = "";
	end
	Player[i].power = round(Player[i].member:GetPower());
	Player[i].maxpower = round(Player[i].member:GetMaxPower());
	Player[i].position = i;
	Player[i].number = i;
	Player[i].effects = Player[i].member:GetEffects();
	Player[i].effect = {};
end

import "EruadarionPlugins.RaidHealz.Visuals";

LowestZOrder = 0;
SaveCheck = true;
SaveCheck2 = true;

BuffString = {};
for i = 1, Settings.EffectIcons.Number, 1 do
	BuffString[i] = Settings.EffectIcons.EffectStrings[i];
end

AlerterString = Settings.PlayerName.AlertString;

--[[if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_1") ~= nil then
	BuffString[1] = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_1");
end
if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_2") ~= nil then
	BuffString[2] = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_2");
end
if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_3") ~= nil then
	BuffString[3] = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_3");
end
if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_4") ~= nil then
	BuffString[4] = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buff_4");
end
if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Alerter") ~= nil then
	AlerterString = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Alerter");
end]]

if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_PosX") ~= nil and Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_PosY") ~= nil then
	MainWindow:SetPosition(Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_PosX"), Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_PosY"));
else
	MainWindow:SetPosition(ScreenWidth / 2 - WindowWidth / 2, ScreenHeight / 1.4 - WindowHeight / 2);
end

function SavePositions()
	for tempIndex = 1, MemberCount, 1 do
		Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_Member_"..Player[tempIndex].position, Player[tempIndex].name);
	end
end

if Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buffs") == "true" or Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Buffs") == nil then
	BuffButtonState = true;
else
	BuffButtonState = false;
end

import "EruadarionPlugins.RaidHealz.SettingsWindow";

ClassIcon = {};
ClassIcon[Turbine.Gameplay.Class.Burglar] = 0x41007deb;
ClassIcon[Turbine.Gameplay.Class.Captain] = 0x41007de7;
ClassIcon[Turbine.Gameplay.Class.Champion] = 0x41007dec;
ClassIcon[Turbine.Gameplay.Class.Guardian] = 0x41007de8;
ClassIcon[Turbine.Gameplay.Class.Hunter] = 0x41007dea;
ClassIcon[Turbine.Gameplay.Class.LoreMaster] = 0x41007de9;
ClassIcon[Turbine.Gameplay.Class.Minstrel] = 0x41007de6;
ClassIcon[Turbine.Gameplay.Class.RuneKeeper] = 0x410ea238;
ClassIcon[Turbine.Gameplay.Class.Warden] = 0x410ea239;
ClassIcon[Turbine.Gameplay.Class.Beorning] = 0x4115370d;
--[[
ClassIcon[Turbine.Gameplay.Class.BlackArrow] = 
ClassIcon[Turbine.Gameplay.Class.Defiler] = 
ClassIcon[Turbine.Gameplay.Class.Reaver] = 
ClassIcon[Turbine.Gameplay.Class.Stalker] = 
ClassIcon[Turbine.Gameplay.Class.WarLeader] = 
ClassIcon[Turbine.Gameplay.Class.Weaver] =
]]

--[[ CREATE CONTROLS ]]
function CreateFrameControls(number)
	local tempIndex;
	FrameControl = {};

	for tempIndex = 1, number, 1 do
		FrameControl[tempIndex] = Turbine.UI.Control();
		FrameControl[tempIndex]:SetParent(MainWindow);
		FrameControl[tempIndex]:SetSize(Settings.MoraleBar.Width + 2, Settings.MoraleBar.Height + 2);
		FrameControl[tempIndex]:SetPosition(X_Coordinates[tempIndex] - 1, Y_Coordinates[tempIndex] - 1);
		FrameControl[tempIndex]:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1, 1));
	end
end

CreateFrameControls(MemberCount);

function CreateEntityControls(number)
	
	local tempIndex;
	EntityControl = {};

	for tempIndex = 1, number, 1 do
		EntityControl[tempIndex] = Turbine.UI.Lotro.EntityControl();
		EntityControl[tempIndex]:SetParent(FrameControl[tempIndex]);
		EntityControl[tempIndex]:SetSize(Settings.MoraleBar.Width, Settings.MoraleBar.Height);
		EntityControl[tempIndex]:SetPosition(1, 1);
	end
	
	for tempIndex = 1, number, 1 do
		EntityControl[tempIndex]:SetEntity(Player[tempIndex].member);
		
		EntityControl[tempIndex].MouseEnter = function()
			if MyTargetName ~= Player[tempIndex].name then
				FrameControl[tempIndex]:SetBackColor(Turbine.UI.Color.White);
			end
		end
		EntityControl[tempIndex].MouseLeave = function()
			if MyTargetName ~= Player[tempIndex].name then
				FrameControl[tempIndex]:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1, 1));
			end
		end
	end
end

CreateEntityControls(MemberCount);

function CreateBackgroundControls(number)
	
	local tempIndex;
	BackgroundControl = {};

	for tempIndex = 1, number, 1 do
		BackgroundControl[tempIndex] = Turbine.UI.Control();
		BackgroundControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		BackgroundControl[tempIndex]:SetSize(Settings.MoraleBar.Width, Settings.MoraleBar.Height);
		BackgroundControl[tempIndex]:SetPosition(0,0);
		BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundColor);
	end
end

CreateBackgroundControls(MemberCount);
	
function CreatePlayerControls(number)
	local tempIndex;
	PlayerControl = {};

	for tempIndex = 1, number, 1 do
		PlayerControl[tempIndex] = Turbine.UI.Control();
		PlayerControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		PlayerControl[tempIndex]:SetSize(Settings.MoraleBar.Width, Settings.MoraleBar.Height);
		PlayerControl[tempIndex]:SetPosition(0,0);
	end
end

CreatePlayerControls(MemberCount);

function CreateBubbleControls(number)
	local tempIndex;
	BubbleControl = {};

	for tempIndex = 1, number, 1 do
		BubbleControl[tempIndex] = Turbine.UI.Control();
		BubbleControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		BubbleControl[tempIndex]:SetSize(0, Settings.MoraleBar.Height);
		BubbleControl[tempIndex]:SetPosition(Settings.MoraleBar.Width,0);
		BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
	end
end

CreateBubbleControls(MemberCount);

function CreateDreadControls(number)
	local tempIndex;
	DreadControl = {};

	for tempIndex = 1, number, 1 do
		DreadControl[tempIndex] = Turbine.UI.Control();
		DreadControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		DreadControl[tempIndex]:SetSize(0, Settings.MoraleBar.Height);
		DreadControl[tempIndex]:SetPosition(Settings.MoraleBar.Width,0);
		DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
	end
end

CreateDreadControls(MemberCount);

function CreatePowerControls(number)
	local tempIndex;
	PowerControl = {};

	for tempIndex = 1, number, 1 do
		PowerControl[tempIndex] = Turbine.UI.Control();
		PowerControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		PowerControl[tempIndex]:SetSize(Settings.PowerBar.Width, Settings.PowerBar.Height);
		PowerControl[tempIndex]:SetPosition(0, Settings.MoraleBar.Height - Settings.PowerBar.Height);
		PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Color);
		if PowerButtonState == false then PowerControl[tempIndex]:SetBackColor("") end
	end

end

CreatePowerControls(MemberCount);

function CreatePlayerLabels(number)

	local tempIndex;
	PlayerLabel = {};

	for tempIndex = 1, number, 1 do
		PlayerLabel[tempIndex] = Turbine.UI.Label();
		PlayerLabel[tempIndex]:SetParent(EntityControl[tempIndex]);
		PlayerLabel[tempIndex]:SetSize(Settings.MoraleBar.Width -2, Settings.MoraleBar.Height -2);
		PlayerLabel[tempIndex]:SetPosition(1, 1);
		PlayerLabel[tempIndex]:SetFont(Settings.PlayerName.Font);
		if Settings.PlayerName.ClassColorsVisible then
			PlayerLabel[tempIndex]:SetForeColor(Settings.PlayerName.ClassColors[Player[tempIndex].class]);
		else
			PlayerLabel[tempIndex]:SetForeColor(Settings.PlayerName.DefaultColor);
		end
		PlayerLabel[tempIndex]:SetOutlineColor(Settings.PlayerName.OutlineColor);
		PlayerLabel[tempIndex]:SetFontStyle( Settings.PlayerName.Outline );
		PlayerLabel[tempIndex]:SetTextAlignment(Settings.PlayerName.Alignment);
		PlayerLabel[tempIndex]:SetText(Player[tempIndex].name_short);
		PlayerLabel[tempIndex].Update = function()
			local CurrentTime = Turbine.Engine:GetGameTime();
			if CurrentTime - StartTime < tonumber(Settings.PlayerName.AlertDuration) then
				PlayerLabel[tempIndex]:SetFont(Settings.PlayerName.AlertFont);
				PlayerLabel[tempIndex]:SetForeColor(Settings.PlayerName.AlertColor);
				PlayerLabel[tempIndex]:SetText(Player[tempIndex].name_short);
			else
				PlayerLabel[tempIndex]:SetFont(Settings.PlayerName.Font);
				if Settings.PlayerName.ClassColorsVisible then
					PlayerLabel[tempIndex]:SetForeColor(Settings.PlayerName.ClassColors[Player[tempIndex].class]);
				else
					PlayerLabel[tempIndex]:SetForeColor(Settings.PlayerName.DefaultColor);
				end
				PlayerLabel[tempIndex]:SetText(Player[tempIndex].name_short);
				PlayerLabel[tempIndex]:SetWantsUpdates(false);
			end
		end
	end
end

CreatePlayerLabels(MemberCount);

function CreateInfoLabels(number)
	
	local tempIndex;
	InfoLabel = {};
	
	for tempIndex = 1, number, 1 do
		InfoLabel[tempIndex] = Turbine.UI.Label();
		InfoLabel[tempIndex]:SetParent(EntityControl[tempIndex]);
		InfoLabel[tempIndex]:SetPosition(1, 1);
		InfoLabel[tempIndex]:SetSize(Settings.MoraleBar.Width -2, Settings.MoraleBar.Height -2);
		InfoLabel[tempIndex]:SetFont(Settings.MoraleLabel.Font);
		if Settings.MoraleLabel.Outline then
			InfoLabel[tempIndex]:SetFontStyle(Turbine.UI.FontStyle.Outline);
			InfoLabel[tempIndex]:SetOutlineColor(Settings.MoraleLabel.OutlineColor);
		end
		InfoLabel[tempIndex]:SetTextAlignment(Settings.MoraleLabel.Alignment);
		InfoLabel[tempIndex]:SetText("");
		
		if Player[tempIndex].morale == 0 then
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundDead);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundDead);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundDead);
				InfoLabel[tempIndex]:SetText(defeatedString);
			elseif Player[tempIndex].morale / Player[tempIndex].maxmorale <= Settings.MoraleBar.Treshold2 then
				if LabelButtonState then InfoLabel[tempIndex]:SetText(Player[tempIndex].moralestring) else InfoLabel[tempIndex]:SetText("") end
				PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.DefaultHighlight2);
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundHighlight2);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
			elseif Player[tempIndex].morale / Player[tempIndex].maxmorale <= Settings.MoraleBar.Treshold1 then
				if LabelButtonState then InfoLabel[tempIndex]:SetText(Player[tempIndex].moralestring) else InfoLabel[tempIndex]:SetText("") end
				if Settings.MoraleBar.ClassColorsVisible then
					PlayerControl[tempIndex]:SetBackColor(Turbine.UI.Color(Settings.MoraleBar.ClassColors[Player[tempIndex].class]));
				else
					PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.DefaultHighlight1);
				end
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundHighlight1);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
			else
				if LabelButtonState then InfoLabel[tempIndex]:SetText(Player[tempIndex].moralestring) else InfoLabel[tempIndex]:SetText("") end
				if Settings.MoraleBar.ClassColorsVisible then
					PlayerControl[tempIndex]:SetBackColor(Turbine.UI.Color(Settings.MoraleBar.ClassColors[Player[tempIndex].class].A - 0.5, Settings.MoraleBar.ClassColors[Player[tempIndex].class].R, Settings.MoraleBar.ClassColors[Player[tempIndex].class].G, Settings.MoraleBar.ClassColors[Player[tempIndex].class].B));
				else
					PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.DefaultNormalColor);
				end
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundColor);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
			end
		
		
		if Player[tempIndex].member:IsLinkDead() then
			PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundLinkLost);
			BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundLinkLost);
			InfoLabel[tempIndex]:SetText(linklostString);
		end
	end
end

CreateInfoLabels(MemberCount);

function CreateClassControls(number)
	
	local tempIndex;
	ClassControl = {};
	
	for tempIndex = 1, number, 1 do
		ClassControl[tempIndex] = Turbine.UI.Control();
		ClassControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		ClassControl[tempIndex]:SetSize(20, 20);
		ClassControl[tempIndex]:SetPosition(Settings.MoraleBar.Width - 20, 0);
		ClassControl[tempIndex]:SetBackground(ClassIcon[Player[tempIndex].class]);
		ClassControl[tempIndex]:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	
		if Settings.ClassIcon.Visible then
			ClassControl[tempIndex]:SetVisible(true);
		else
			ClassControl[tempIndex]:SetVisible(false);
		end
	end
	
end

CreateClassControls(MemberCount);

function CreateBuffControls(number)
	
	BuffControl = {};
	BuffCountdownLabel = {};
	Buff_X = {};
	Buff_Y = {};
	
	if Settings.EffectIcons.Position == 1 then -- top left
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = 1 + (Settings.EffectIcons.Size + 1) * (i - 1);
			Buff_Y[i] = 1;
		end
	elseif Settings.EffectIcons.Position == 2 then -- top center
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = (Settings.MoraleBar.Width / 2) - ((Settings.EffectIcons.Size + 1) * (Settings.EffectIcons.Number)) / 2 + (Settings.EffectIcons.Size + 1) * (i - 1);
			Buff_Y[i] = 1;
		end
	elseif Settings.EffectIcons.Position == 3 then -- top right
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = Settings.MoraleBar.Width - (Settings.EffectIcons.Size + 1) * i;
			Buff_Y[i] = 1;
		end
	elseif Settings.EffectIcons.Position == 4 then -- middle left
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = 1 + (Settings.EffectIcons.Size + 1) * (i - 1);
			Buff_Y[i] = (Settings.MoraleBar.Height / 2) - (Settings.EffectIcons.Size / 2);
		end
	elseif Settings.EffectIcons.Position == 5 then -- middle center
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = (Settings.MoraleBar.Width / 2) - ((Settings.EffectIcons.Size + 1) * (Settings.EffectIcons.Number)) / 2 + (Settings.EffectIcons.Size + 1) * (i - 1);
			Buff_Y[i] = (Settings.MoraleBar.Height / 2) - (Settings.EffectIcons.Size / 2);
		end
	elseif Settings.EffectIcons.Position == 6 then -- middle right
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = Settings.MoraleBar.Width - (Settings.EffectIcons.Size + 1) * i;
			Buff_Y[i] = (Settings.MoraleBar.Height / 2) - (Settings.EffectIcons.Size / 2);
		end
	elseif Settings.EffectIcons.Position == 7 then -- bottom left
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = 1 + (Settings.EffectIcons.Size + 1) * (i - 1);
			Buff_Y[i] = Settings.MoraleBar.Height - (Settings.EffectIcons.Size + 1);
		end
	elseif Settings.EffectIcons.Position == 8 then -- bottom center
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = (Settings.MoraleBar.Width / 2) - ((Settings.EffectIcons.Size + 1) * (Settings.EffectIcons.Number)) / 2 + (Settings.EffectIcons.Size + 1) * (i - 1);
			Buff_Y[i] = Settings.MoraleBar.Height - (Settings.EffectIcons.Size + 1);
		end
	elseif Settings.EffectIcons.Position == 9 then -- bottom left
		for i = 1, Settings.EffectIcons.Number, 1 do
			Buff_X[i] = Settings.MoraleBar.Width - (Settings.EffectIcons.Size + 1) * i;
			Buff_Y[i] = Settings.MoraleBar.Height - (Settings.EffectIcons.Size + 1);
		end
	end
	
	for tempIndex = 1, number, 1 do
		BuffControl[tempIndex] = {};
		BuffCountdownLabel[tempIndex] = {};
		for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do
			BuffControl[tempIndex][tempIndex2] = Turbine.UI.Control();
			BuffControl[tempIndex][tempIndex2]:SetParent(EntityControl[tempIndex]);
			BuffControl[tempIndex][tempIndex2]:SetSize(32, 32);
			BuffControl[tempIndex][tempIndex2]:SetPosition(Buff_X[tempIndex2], Buff_Y[tempIndex2]);
			BuffCountdownLabel[tempIndex][tempIndex2] = Turbine.UI.Label();
			BuffCountdownLabel[tempIndex][tempIndex2]:SetParent(BuffControl[tempIndex][tempIndex2]);
			BuffCountdownLabel[tempIndex][tempIndex2]:SetSize(34, 32);
			BuffCountdownLabel[tempIndex][tempIndex2]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			BuffCountdownLabel[tempIndex][tempIndex2]:SetFontStyle(Turbine.UI.FontStyle.Outline);
			BuffCountdownLabel[tempIndex][tempIndex2]:SetOutlineColor(Turbine.UI.Color.Black);
			BuffCountdownLabel[tempIndex][tempIndex2]:SetFont(Turbine.UI.Lotro.Font.Verdana22);
			BuffCountdownLabel[tempIndex][tempIndex2]:SetForeColor(Turbine.UI.Color.White);
		end
	end	
end

CreateBuffControls(MemberCount);

function CreateDragControl(number)
	local tempIndex;
	
	DragControl = {};
	
	for tempIndex = 1, number, 1 do
		DragControl[tempIndex] = Turbine.UI.Control();
		DragControl[tempIndex]:SetParent(EntityControl[tempIndex]);
		DragControl[tempIndex]:SetSize(Settings.MoraleBar.Width, Settings.MoraleBar.Height);
		DragControl[tempIndex]:SetPosition(0, 0);
		DragControl[tempIndex].SwapState = false;
		DragControl[tempIndex]:SetVisible(false);
		
		DragControl[tempIndex].MouseDown = function(sender, args)
				DragControl[tempIndex].dragStartX = args.X;
				DragControl[tempIndex].dragStartY = args.Y;
				DragControl[tempIndex].dragging = true;
				LowestZOrder = LowestZOrder - 1;
				FrameControl[tempIndex]:SetZOrder(LowestZOrder);
		end
			
		DragControl[tempIndex].MouseMove = function( sender, args )
			local left, top = FrameControl[tempIndex]:GetPosition();
			
			if ( DragControl[tempIndex].dragging ) then
				FrameControl[tempIndex]:SetPosition( left + ( args.X - DragControl[tempIndex].dragStartX ), top + ( args.Y - DragControl[tempIndex].dragStartY ) );
			end
		end

		DragControl[tempIndex].MouseUp = function( sender, args )
			if DragControl[tempIndex].SwapState == true then
				--
			else
				FrameControl[tempIndex]:SetPosition(X_Coordinates[Player[tempIndex].position] - 1, Y_Coordinates[Player[tempIndex].position] - 1);
			end
		
			DragControl[tempIndex].dragging = false;
		end
		
		DragControl[tempIndex].MouseEnter = function()
			local tempIndex2;
			for tempIndex2 = 1, number, 1 do
				if tempIndex2 ~= Player[tempIndex].number then
					if DragControl[tempIndex2].dragging == true then
						ChangeMembers(Player[tempIndex].position, Player[tempIndex2].position);
						FrameControl[tempIndex]:SetPosition(X_Coordinates[Player[tempIndex].position] - 1, Y_Coordinates[Player[tempIndex].position] - 1);
					end
				end
			end
		end
	end
end

CreateDragControl(MemberCount);


--[[ INITIALISE ALL -CHANGED FUNCTIONS]]

moraleChangeMasterFunction = function(tempIndex)
	Player[tempIndex].morale = Player[tempIndex].member:GetMorale();
			Player[tempIndex].maxmorale = Player[tempIndex].member:GetMaxMorale();
			Player[tempIndex].basemaxmorale = Player[tempIndex].member:GetBaseMaxMorale();
			Player[tempIndex].temporarymorale = Player[tempIndex].member:GetTemporaryMorale();
			Player[tempIndex].maxtemporarymorale = Player[tempIndex].member:GetMaxTemporaryMorale();
			
			if Settings.FillMode == 1 then
				PlayerControl[tempIndex]:SetPosition(0, 0);
				PlayerControl[tempIndex]:SetSize(math.floor(Settings.MoraleBar.Width * (Player[tempIndex].morale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))), Settings.MoraleBar.Height);
				BubbleControl[tempIndex]:SetPosition(math.floor(Settings.MoraleBar.Width * (Player[tempIndex].maxmorale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))) + 1, 0);
				BubbleControl[tempIndex]:SetSize(math.floor(Settings.MoraleBar.Width * (Player[tempIndex].temporarymorale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))), Settings.MoraleBar.Height);
				DreadControl[tempIndex]:SetPosition(math.floor(Settings.MoraleBar.Width * ((Player[tempIndex].maxmorale + Player[tempIndex].maxtemporarymorale) / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))) + 1, 0);
				DreadControl[tempIndex]:SetSize(math.floor(Settings.MoraleBar.Width * ((Player[tempIndex].basemaxmorale - Player[tempIndex].maxmorale) / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))), Settings.MoraleBar.Height);
			elseif Settings.FillMode == 2 then
				PlayerControl[tempIndex]:SetPosition(0, math.floor(Settings.MoraleBar.Height - (Settings.MoraleBar.Height * (Player[tempIndex].morale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale)))));
				PlayerControl[tempIndex]:SetSize(Settings.MoraleBar.Width, math.floor(Settings.MoraleBar.Height * (Player[tempIndex].morale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))));
				BubbleControl[tempIndex]:SetPosition(0, math.floor(Settings.MoraleBar.Height - (Settings.MoraleBar.Height * (Player[tempIndex].maxmorale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale)))));
				BubbleControl[tempIndex]:SetSize(Settings.MoraleBar.Width, math.floor(Settings.MoraleBar.Height * (Player[tempIndex].temporarymorale / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))));
				DreadControl[tempIndex]:SetPosition(0, 0);
				DreadControl[tempIndex]:SetSize(Settings.MoraleBar.Width, math.floor(Settings.MoraleBar.Height * ((Player[tempIndex].basemaxmorale - Player[tempIndex].maxmorale) / (Player[tempIndex].basemaxmorale + Player[tempIndex].maxtemporarymorale))));
			end
			
			
			if Settings.MoraleLabel.Mode == 1 then
				if Settings.MoraleLabel.Short then
					Player[tempIndex].moralestring = math.floor(Player[tempIndex].morale / 1000).."."..math.floor(((Player[tempIndex].morale % 1000) + 50) / 100).."/"..math.floor(Player[tempIndex].maxmorale / 1000).."."..math.floor(((Player[tempIndex].maxmorale % 1000) + 50) / 100);
				else
					Player[tempIndex].moralestring = formatNumber(math.floor(Player[tempIndex].morale)).."/"..formatNumber(math.floor(Player[tempIndex].maxmorale));
				end
			elseif Settings.MoraleLabel.Mode == 2 and Player[tempIndex].morale ~= Player[tempIndex].maxmorale then
				if Settings.MoraleLabel.Short then
					Player[tempIndex].moralestring = "-"..math.floor((Player[tempIndex].maxmorale - Player[tempIndex].morale) / 1000).."."..math.floor((((Player[tempIndex].maxmorale - Player[tempIndex].morale) % 1000) + 50) / 100);
				else
					Player[tempIndex].moralestring = "-"..formatNumber(math.floor(Player[tempIndex].maxmorale - Player[tempIndex].morale));
				end
			else
				if Settings.MoraleLabel.Short then
					Player[tempIndex].moralestring = math.floor(Player[tempIndex].maxmorale / 1000).."."..math.floor(((Player[tempIndex].maxmorale % 1000) + 50) / 100);
				else
					Player[tempIndex].moralestring = formatNumber(math.floor(Player[tempIndex].maxmorale));
				end
			end
			
			if Settings.MoraleLabel.Visible then
				InfoLabel[tempIndex]:SetText(Player[tempIndex].moralestring);
			else
				InfoLabel[tempIndex]:SetText("");
			end
			
			if Player[tempIndex].morale == 0 then
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundDead);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundDead);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundDead);
				InfoLabel[tempIndex]:SetText(defeatedString);
				
				for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do
					if Player[tempIndex].effect[tempIndex2] ~= nil then
						if Player[tempIndex].effect[tempIndex2].StartTime + Player[tempIndex].effect[tempIndex2].Duration > Turbine.Engine.GetGameTime() then
							Player[tempIndex].effect[tempIndex2].StartTime = Turbine.Engine.GetGameTime();
							Player[tempIndex].effect[tempIndex2].Duration = 3;
							Player[tempIndex].effect[tempIndex2].Exception = true;
						end
					end
				end
			elseif Player[tempIndex].morale / Player[tempIndex].maxmorale <= Settings.MoraleBar.Treshold2 then
				PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.DefaultHighlight2);
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundHighlight2);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
			elseif Player[tempIndex].morale / Player[tempIndex].maxmorale <= Settings.MoraleBar.Treshold1 then
				if Settings.MoraleBar.ClassColorsVisible then
					PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.ClassColors[Player[tempIndex].class]);
				else
					PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.DefaultHighlight1);
				end
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundHighlight1);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
			else
				if Settings.MoraleBar.ClassColorsVisible then
					PlayerControl[tempIndex]:SetBackColor(Turbine.UI.Color(Settings.MoraleBar.ClassColors[Player[tempIndex].class].A - 0.5, Settings.MoraleBar.ClassColors[Player[tempIndex].class].R, Settings.MoraleBar.ClassColors[Player[tempIndex].class].G, Settings.MoraleBar.ClassColors[Player[tempIndex].class].B));
				else
					PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.DefaultNormalColor);
				end
				BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundColor);
				BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BubbleColor);
				DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.DreadColor);
			end
end

function InitializeMoraleChange()
	for tempIndex = 1, MemberCount, 1 do
		Player[tempIndex].member.MoraleChanged = function(sender, args)
			moraleChangeMasterFunction(tempIndex);
		end
	end
	
end

InitializeMoraleChange();

function InitializeMaxMoraleChange()
		for tempIndex = 1, MemberCount, 1 do
		Player[tempIndex].member.MaxMoraleChanged = function(sender, args)
			moraleChangeMasterFunction(tempIndex);
		end
	end
end
	
InitializeMaxMoraleChange();

function InitializeBaseMaxMoraleChange()
		for tempIndex = 1, MemberCount, 1 do
		Player[tempIndex].member.BaseMaxMoraleChanged = function(sender, args)
			moraleChangeMasterFunction(tempIndex);
		end
	end
end
	
InitializeBaseMaxMoraleChange();

function InitializeTemporaryMoraleChange()
		for tempIndex = 1, MemberCount, 1 do
		Player[tempIndex].member.TemporaryMoraleChanged = function(sender, args)
			moraleChangeMasterFunction(tempIndex);
		end
	end
end
	
InitializeTemporaryMoraleChange();

function InitializeMaxTemporaryMoraleChange()
		for tempIndex = 1, MemberCount, 1 do
		Player[tempIndex].member.MaxTemporaryMoraleChanged = function(sender, args)
			moraleChangeMasterFunction(tempIndex);
		end
	end
end
	
InitializeMaxTemporaryMoraleChange();

function InitializePowerChange()

	for tempIndex = 1, MemberCount, 1 do
		if Player[tempIndex].class ~= Turbine.Gameplay.Class.Beorning then
			Player[tempIndex].member.PowerChanged = function(sender, args)
				if Settings.PowerBar.Visible == true then
					
					Player[tempIndex].power = Player[tempIndex].member:GetPower();
					Player[tempIndex].maxpower = Player[tempIndex].member:GetMaxPower();
				
					PowerControl[tempIndex]:SetSize(math.floor(Settings.PowerBar.Width * Player[tempIndex].power / Player[tempIndex].maxpower), Settings.PowerBar.Height);
					if Player[tempIndex].power / Player[tempIndex].maxpower <= Settings.PowerBar.Treshold2 then
						PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Highlight2);
					elseif Player[tempIndex].power / Player[tempIndex].maxpower <= Settings.PowerBar.Treshold1 then
						PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Highlight1);
					else
						PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Color);
					end
				end
			end
		end
	end
	
end
	
InitializePowerChange();

function InitializeMaxPowerChange()
	for tempIndex = 1, MemberCount, 1 do
		if Player[tempIndex].class ~= Turbine.Gameplay.Class.Beorning then
			Player[tempIndex].member.MaxPowerChanged = function(sender, args)
				if Settings.PowerBar.Visible == true then
					
					Player[tempIndex].power = Player[tempIndex].member:GetPower();
					Player[tempIndex].maxpower = Player[tempIndex].member:GetMaxPower();
				
					PowerControl[tempIndex]:SetSize(math.floor(Settings.PowerBar.Width * Player[tempIndex].power / Player[tempIndex].maxpower), Settings.PowerBar.Height);
					if Player[tempIndex].power / Player[tempIndex].maxpower <= Settings.PowerBar.Treshold2 then
						PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Highlight2);
					elseif Player[tempIndex].power / Player[tempIndex].maxpower <= Settings.PowerBar.Treshold1 then
						PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Highlight1);
					else
						PowerControl[tempIndex]:SetBackColor(Settings.PowerBar.Color);
					end
				end
			end
		end
	end
end
	
InitializeMaxPowerChange();
	
	
	
--[[ TARGET FRAMES AND LINK DEAD]]

MyTargetName = "";

MyPlayer.TargetChanged=function()
    MyTarget = MyPlayer:GetTarget();
	local tempIndex;
	local tempIndex2;
    if MyTarget ~= nil then
        MyTargetName = MyTarget:GetName();
		for tempIndex = 1, MemberCount, 1 do
			if MyTargetName == Player[tempIndex].name then
				FrameControl[tempIndex]:SetBackColor(Turbine.UI.Color.Yellow);
			else
				FrameControl[tempIndex]:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1, 1));
			end
		end
    else
        MyTargetName = "";
		for tempIndex = 1, MemberCount, 1 do
			FrameControl[tempIndex]:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1, 1));
		end
    end
end

for tempIndex = 1, MemberCount, 1 do
	if Player[tempIndex].member:IsLinkDead() then
		PlayerControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundLinkLost);
		BackgroundControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundLinkLost);
		BubbleControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundLinkLost);
		DreadControl[tempIndex]:SetBackColor(Settings.MoraleBar.BackgroundLinkLost);
		InfoLabel[tempIndex]:SetText(linklostString);
	end
	
	Player[tempIndex].member.IsLinkDeadChanged = function(sender, args)
		if Player[tempIndex].member:IsLinkDead() == true then
			PlayerControl[tempIndex]:SetBackColor(Turbine.UI.Color.DarkSlateGray);
			BackgroundControl[tempIndex]:SetBackColor(Turbine.UI.Color.DarkSlateGray);
			InfoLabel[tempIndex]:SetText("Link Dead");
		else 
			PlayerControl[tempIndex]:SetBackColor(Turbine.UI.Color(0.5, 0, 0.4, 0));
			BackgroundControl[tempIndex]:SetBackColor(Turbine.UI.Color(0.8, 0.3, 0.3, 0.3));
			InfoLabel[tempIndex]:SetText("");
		end
	end
end


--[[ RELOAD WHEN MEMBER JOINS OR LEAVES ]]

if MyParty ~= nil then
	MyParty.MemberAdded = function()
		SavePositions();
		if not SettingsWindow:IsVisible() then
			Turbine.PluginManager.LoadPlugin("RaidHealzReloader");
		end
	end

	MyParty.MemberRemoved = function()
		SavePositions();
		if not SettingsWindow:IsVisible() then
			Turbine.PluginManager.LoadPlugin("RaidHealzReloader");
		end
	end
end


--[[ MOVE THE MAIN WINDOW ]]

function MainWindow:MouseDown( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
		self.dragging = true;
	end
end
	
function MainWindow:MouseMove( args )
	local left, top = self:GetPosition();
	
	if ( self.dragging ) then
		self:SetPosition( left + ( args.X - self.dragStartX ), top + ( args.Y - self.dragStartY ) );
		WindowPosX = left + ( args.X - self.dragStartX );
		WindowPosY = top + ( args.Y - self.dragStartY );
	end
end

function MainWindow:MouseUp( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
		self.dragging = false;
		Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_PosX", WindowPosX);
		Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_PosY", WindowPosY);
	end
end


--[[ CHANGE MEMBER POSITIONS ]]
function ChangeMembers(position1, position2)
	
	local tempIndex;
	local number1;
	local number2;
	local PosX_1, PosY_1;
	local PosX_2, PosY_2;
	
	
	if position1 > 0 and position1 <= MemberCount and position2 > 0 and position2 <= MemberCount then
		
		for tempIndex = 1, MemberCount, 1 do
			if	Player[tempIndex].position == position1 then
				number1 = Player[tempIndex].number;
			end
			if Player[tempIndex].position == position2 then
				number2 = Player[tempIndex].number;
			end
		end
	
		PosX_1, PosY_1 = FrameControl[number1]:GetPosition();
		PosX_2, PosY_2 = FrameControl[number2]:GetPosition();
	
		FrameControl[number1]:SetPosition(PosX_2, PosY_2);
		FrameControl[number2]:SetPosition(PosX_1, PosY_1);
		
		Player[number1].position, Player[number2].position = Player[number2].position, Player[number1].position;
		
		if SaveCheck2 == true then
			Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_Member_"..Player[number1].position, Player[number1].name);
			if SaveCheck == true then
				Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_Member_"..Player[number2].position, Player[number2].name);
			end
		end
	end
end

SaveCheck_2 = false;
for tempIndex = 1, MemberCount, 1 do
	if Player[tempIndex].name == MyPlayer:GetName() then
		ChangeMembers(tempIndex, 1);
	end
end
SaveCheck2 = true;

MyPlayer.PartyChanged = function()
	SavePositions();
	if not SettingsWindow:IsVisible() then
		Turbine.PluginManager.LoadPlugin("RaidHealzReloader");
	end
end

LoadPos = {};

for tempIndex=1, MemberCount, 1 do
	LoadPos[tempIndex] = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidHealz_Member_"..tempIndex);
end

PlayerPosName = {};

SaveCheck = false;
for tempIndex = 1, MemberCount, 1 do
	PlayerPosName[Player[tempIndex].position] = Player[tempIndex].name;
end
for tempIndex = 1, MemberCount, 1 do
	if LoadPos[tempIndex] ~= PlayerPosName[tempIndex] then
		for tempIndex2 = tempIndex + 1, MemberCount, 1 do
			if LoadPos[tempIndex] == PlayerPosName[tempIndex2] then
				ChangeMembers(tempIndex, tempIndex2);
			end
		end
	end
end
SaveCheck = true;



-- [[ CHAT FUNCTIONS ]]

function Turbine.Chat.Received(sender, args)
	local message_begin;
	local message_end;
	
	if args.ChatType == Turbine.ChatType.Standard then
		message_begin, message_end = string.find(args.Message," hat sich Eurem Schlachtzug angeschlossen");
		if message_begin ~= nil then
			SavePositions();
			if not SettingsWindow:IsVisible() then
				Turbine.PluginManager.LoadPlugin("RaidHealzReloader");
			end
		end
		message_begin, message_end = string.find(args.Message," has joined your Raid.");
		if message_begin ~= nil then
			SavePositions();
			if not SettingsWindow:IsVisible() then
				Turbine.PluginManager.LoadPlugin("RaidHealzReloader");
			end
		end
	
	elseif args.ChatType == Turbine.ChatType.Say then
		message_begin, message_end = string.find(args.Message, AlerterString);
		if message_begin ~= nil then
			local tempIndex;
			local message_begin2;
			local message_end2;
			for tempIndex = 1, MemberCount, 1 do
				message_begin2, message_end2 = string.find(args.Message, Player[tempIndex].name);
				if message_begin2 ~= nil then
					StartTime = Turbine.Engine:GetGameTime();
					PlayerLabel[tempIndex]:SetWantsUpdates(true);
				end
			end
		end
	end
end


-- [[ EFFECTS ]]
for tempIndex = 1, MemberCount, 1 do
	if not (Player[tempIndex].name == MyName) then
		Player[tempIndex].effects.EffectAdded = function(sender, args)
			local newEffect = Player[tempIndex].member:GetEffects():Get(args.Index);
			local EffectName = newEffect:GetName();
			local EffectIcon = newEffect:GetIcon();
			local tempIndex2;
			for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do
				local NameBegin, NameEnd;
				NameBegin, NameEnd = string.find(EffectName, BuffString[tempIndex2]);
				if NameBegin ~= nil then
					Player[tempIndex].effect[tempIndex2] = Player[tempIndex].member:GetEffects():Get(args.Index);
					Player[tempIndex].effect[tempIndex2].Duration = Player[tempIndex].effect[tempIndex2]:GetDuration();
					Player[tempIndex].effect[tempIndex2].StartTime = Player[tempIndex].effect[tempIndex2]:GetStartTime();
					if Player[tempIndex].effect[tempIndex2]:GetDuration() > 999 or Player[tempIndex].effect[tempIndex2]:IsCurable() then
						Player[tempIndex].effect[tempIndex2].Duration = 3;
						Player[tempIndex].effect[tempIndex2].Exception = true;
					else
						Player[tempIndex].effect[tempIndex2].Exception = false;
					end
					BuffControl[tempIndex][tempIndex2]:SetBackground(EffectIcon);
					BuffControl[tempIndex][tempIndex2]:SetStretchMode(1);
					BuffControl[tempIndex][tempIndex2]:SetSize(Settings.EffectIcons.Size, Settings.EffectIcons.Size);
					if not BuffButtonState then
						BuffControl[tempIndex][tempIndex2]:SetVisible(false);
					end
				break;
				end
			end
		end
	else
		Player[tempIndex].effects.EffectAdded = function(sender, args)
			local newEffect = Player[tempIndex].member:GetEffects():Get(args.Index);
			local EffectName = newEffect:GetName();
			local EffectIcon = newEffect:GetIcon();
			local tempIndex2;
			for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do
				local NameBegin, NameEnd;
				NameBegin, NameEnd = string.find(EffectName, BuffString[tempIndex2]);
				if NameBegin ~= nil then
					Player[tempIndex].effect[tempIndex2] = Player[tempIndex].member:GetEffects():Get(args.Index);
					Player[tempIndex].effect[tempIndex2].Duration = Player[tempIndex].effect[tempIndex2]:GetDuration();
					Player[tempIndex].effect[tempIndex2].StartTime = Player[tempIndex].effect[tempIndex2]:GetStartTime();
					if Player[tempIndex].effect[tempIndex2]:GetDuration() > 999 then
						Player[tempIndex].effect[tempIndex2].Exception = true;
					else
						Player[tempIndex].effect[tempIndex2].Exception = false;
					end
					BuffControl[tempIndex][tempIndex2]:SetBackground(EffectIcon);
					BuffControl[tempIndex][tempIndex2]:SetStretchMode(1);
					BuffControl[tempIndex][tempIndex2]:SetSize(Settings.EffectIcons.Size, Settings.EffectIcons.Size);
					if not BuffButtonState then
						BuffControl[tempIndex][tempIndex2]:SetVisible(false);
					else
						BuffControl[tempIndex][tempIndex2]:SetVisible(true);
					end
				break;
				end
			end
		end
		Player[tempIndex].effects.EffectRemoved = function(sender, args)
			local tempIndex2;
			for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do
				if Player[tempIndex].member:GetEffects():Contains(Player[tempIndex].effect[tempIndex2]) == false then
					BuffControl[tempIndex][tempIndex2]:SetVisible(false);
				end
			end
		end
	end
end


FirstEffectName = {};
FirstEffectIcon = {};

function SetFirstBuffs()
	for tempIndex = 1, MemberCount, 1 do
		if not (Player[tempIndex].name == MyName) then
			local tempIndex3
			local EffectNumber = Player[tempIndex].member:GetEffects():GetCount();
				
			for tempIndex3 = 1, EffectNumber, 1 do
				FirstEffectName[tempIndex3] = Player[tempIndex].member:GetEffects():Get(tempIndex3):GetName();
				FirstEffectIcon[tempIndex3] = Player[tempIndex].member:GetEffects():Get(tempIndex3):GetIcon();
				local tempIndex2;
				
				for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do	
					local NameBegin, NameEnd;
					NameBegin, NameEnd = string.find(FirstEffectName[tempIndex3], BuffString[tempIndex2]);
					if NameBegin ~= nil then
						Player[tempIndex].effect[tempIndex2] = Player[tempIndex].member:GetEffects():Get(tempIndex3);
						Player[tempIndex].effect[tempIndex2].Duration = Player[tempIndex].effect[tempIndex2]:GetDuration();
						Player[tempIndex].effect[tempIndex2].StartTime = Player[tempIndex].effect[tempIndex2]:GetStartTime();
						if Player[tempIndex].effect[tempIndex2]:GetDuration() > 999 or Player[tempIndex].effect[tempIndex2]:IsCurable() then
							Player[tempIndex].effect[tempIndex2].Duration = 3;
							Player[tempIndex].effect[tempIndex2].StartTime = Turbine.Engine.GetGameTime();
							Player[tempIndex].effect[tempIndex2].Exception = true;
						else
							Player[tempIndex].effect[tempIndex2].Exception = false;
						end
						BuffControl[tempIndex][tempIndex2]:SetBackground(FirstEffectIcon[tempIndex3]);
						BuffControl[tempIndex][tempIndex2]:SetStretchMode(1);
						BuffControl[tempIndex][tempIndex2]:SetSize(Settings.EffectIcons.Size, Settings.EffectIcons.Size);
						if not BuffButtonState then
							BuffControl[tempIndex][tempIndex2]:SetVisible(false);
						end
						break;
					end
				end
			end
		else
			local tempIndex3
			local EffectNumber = Player[tempIndex].member:GetEffects():GetCount();
				
			for tempIndex3 = 1, EffectNumber, 1 do
				FirstEffectName[tempIndex3] = Player[tempIndex].member:GetEffects():Get(tempIndex3):GetName();
				FirstEffectIcon[tempIndex3] = Player[tempIndex].member:GetEffects():Get(tempIndex3):GetIcon();
				local tempIndex2;
				
				for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do	
					local NameBegin, NameEnd;
					NameBegin, NameEnd = string.find(FirstEffectName[tempIndex3], BuffString[tempIndex2]);
					if NameBegin ~= nil then
						Player[tempIndex].effect[tempIndex2] = Player[tempIndex].member:GetEffects():Get(tempIndex3);
						Player[tempIndex].effect[tempIndex2].Duration = Player[tempIndex].effect[tempIndex2]:GetDuration();
						Player[tempIndex].effect[tempIndex2].StartTime = Player[tempIndex].effect[tempIndex2]:GetStartTime();
						if Player[tempIndex].effect[tempIndex2]:GetDuration() > 999 then
							Player[tempIndex].effect[tempIndex2].Exception = true;
						else
							Player[tempIndex].effect[tempIndex2].Exception = false;
						end
						BuffControl[tempIndex][tempIndex2]:SetBackground(FirstEffectIcon[tempIndex3]);
						BuffControl[tempIndex][tempIndex2]:SetStretchMode(1);
						BuffControl[tempIndex][tempIndex2]:SetSize(Settings.EffectIcons.Size, Settings.EffectIcons.Size);
						if not BuffButtonState then
							BuffControl[tempIndex][tempIndex2]:SetVisible(false);
						end
						break;
					end
				end
			end
		end
	end
end

SetFirstBuffs();


-- [[ CHANGE MEMBERS WITH F1-F6 BUTTONS ]]

MainWindow.KeyDown = function(sender, args)
	if args.Action == 268435500 then -- fellow 1
		local target = MyPlayer:GetTarget();
		local PosNumber;
		local tempIndex;
		
		for tempIndex = 1, MemberCount, 1 do
			if target:GetName() == Player[tempIndex].name then
				PosNumber = tempIndex;
			end
		end
		
		if Player[PosNumber].position ~= 1 then
			ChangeMembers(1, Player[PosNumber].position);
		end
	elseif args.Action == 268435596 then -- fellow 2
		local target = MyPlayer:GetTarget();
		if target ~= nil then
			local PosNumber;
			local tempIndex;
			
			for tempIndex = 1, MemberCount, 1 do
				if target:GetName() == Player[tempIndex].name then
					PosNumber = tempIndex;
				end
			end
			
			if Player[PosNumber].position ~= 2 then
				ChangeMembers(2, Player[PosNumber].position);
			end
		end
	elseif args.Action == 268435538 then -- fellow 3
		local target = MyPlayer:GetTarget();
		if target ~= nil then
			local PosNumber;
			local tempIndex;
			
			for tempIndex = 1, MemberCount, 1 do
				if target:GetName() == Player[tempIndex].name then
					PosNumber = tempIndex;
				end
			end
			
			if Player[PosNumber].position ~= 3 then
				ChangeMembers(3, Player[PosNumber].position);
			end
		end
	elseif args.Action == 268435595 then -- fellow 4
		local target = MyPlayer:GetTarget();
		if target ~= nil then
			local PosNumber;
			local tempIndex;
			
			for tempIndex = 1, MemberCount, 1 do
				if target:GetName() == Player[tempIndex].name then
					PosNumber = tempIndex;
				end
			end
			
			if Player[PosNumber].position ~= 4 then
				ChangeMembers(4, Player[PosNumber].position);
			end
		end
	elseif args.Action == 268435464 then -- fellow 5
		local target = MyPlayer:GetTarget();
		if target ~= nil then
			local PosNumber;
			local tempIndex;
			
			for tempIndex = 1, MemberCount, 1 do
				if target:GetName() == Player[tempIndex].name then
					PosNumber = tempIndex;
				end
			end
			
			if Player[PosNumber].position ~= 5 then
				ChangeMembers(5, Player[PosNumber].position);
			end
		end
	elseif args.Action == 268435523 then -- fellow 6
		local target = MyPlayer:GetTarget();
		if target ~= nil then
			local PosNumber;
			local tempIndex;
			
			for tempIndex = 1, MemberCount, 1 do
				if target:GetName() == Player[tempIndex].name then
					PosNumber = tempIndex;
				end
			end
			
			if Player[PosNumber].position ~= 6 then
				ChangeMembers(6, Player[PosNumber].position);
			end
		end
	end
end


-- [[ MORE EFFECTS ]]

function CheckEffects(--[[effects]])
	local tempIndex;
	for tempIndex = 1, MemberCount, 1 do
		for tempIndex2 = 1, Settings.EffectIcons.Number, 1 do
			if Player[tempIndex].effect[tempIndex2] ~= nil then
				if (Turbine.Engine:GetGameTime() - Player[tempIndex].effect[tempIndex2].StartTime < Player[tempIndex].effect[tempIndex2].Duration) then
					if not (Player[tempIndex].name == MyName) then
						BuffControl[tempIndex][tempIndex2]:SetVisible(true);
					end
					local effectTime = math.floor(Player[tempIndex].effect[tempIndex2].Duration - (Turbine.Engine.GetGameTime() - Player[tempIndex].effect[tempIndex2].StartTime) + 0.5);
					if not (effectTime > 600) and not Player[tempIndex].effect[tempIndex2].Exception then
						BuffCountdownLabel[tempIndex][tempIndex2]:SetText(effectTime);
					elseif Player[tempIndex].effect[tempIndex2].Exception then
						BuffCountdownLabel[tempIndex][tempIndex2]:SetText("");
					end
				else
					BuffControl[tempIndex][tempIndex2]:SetVisible(false);
				end
			end
			--[[for k, v in pairs(effects) do
				if Player[tempIndex].effect[tempIndex2] ~= nil then
					if Player[tempIndex].effect[tempIndex2]:GetID() == k then
						BuffControl[tempIndex][tempIndex2]:SetVisible(true);
						local effectTime = math.floor(Player[tempIndex].effect[tempIndex2]:GetDuration() - (Turbine.Engine.GetGameTime() - Player[tempIndex].effect[tempIndex2]:GetStartTime()) + 0.5);
						if not (effectTime > 99) then
							BuffCountdownLabel[tempIndex][tempIndex2]:SetText(effectTime);
						end
						break;
					else
						BuffControl[tempIndex][tempIndex2]:SetVisible(false);
					end
				end
			end]]
		end
	end
end

EffectWindow = Turbine.UI.Window();
EffectWindow.nextUpdate = Turbine.Engine:GetGameTime();
EffectWindow.actors = {};
EffectWindow.effectPoll = 0.5;

function EffectWindow:Update()

	if self.nextUpdate <= Turbine.Engine.GetGameTime() then
		CheckEffects();
		--[[Turbine.PluginManager.LoadPlugin("PartyEffects2");
		for _, command in pairs(Turbine.Shell.GetCommands()) do
			if string.sub(command, 1, 8) == "effects-" then
				command = string.sub(command, 9);
				local t = { };
				for id in string.gmatch(command, "%d+") do
					t[tonumber(id)] = true;
				end
				CheckEffects(t);
				break;
			end
		end
		Turbine.PluginManager.UnloadScriptState("PartyEffects2");]]
		self.nextUpdate = self.nextUpdate + self.effectPoll;
	end
end

if BuffButtonState == true then
	EffectWindow:SetWantsUpdates(true);
else
	EffectWindow:SetWantsUpdates(false);
end

visible = Turbine.ShellCommand();
invisible = Turbine.ShellCommand();


--[[ CHAT COMMANDS ]]

function visible:Execute(c,a)
	MainWindow:SetVisible(true);
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, false );
end

function invisible:Execute(c,a)
	MainWindow:SetVisible(false);
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, true );
end

Turbine.Shell.AddCommand("rh_visible", visible);
Turbine.Shell.AddCommand("rh_invisible", invisible);

if Settings.PartyVitalsVisible then
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, true)
else
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, false)
end
if Settings.PlayerVitalsVisible then
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, true)
else
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, false)
end
if Settings.TargetVitalsVisible then
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, true)
else
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, false)
end
for tempIndex = 1, MemberCount, 1 do
	moraleChangeMasterFunction(tempIndex);
end








